using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Spacewar
{
    public struct rule
    {
        public String Condition;
        public String Action;
        public String RuleName;

        rule(String condString, String actString, String nameString)
        {
            Condition = condString;
            Action = actString;
            RuleName = nameString;
        }
    }
    public partial class RuleForm : Form
    {
      
        rule newRule;
        rule[] rules = new rule[10];
        int numRules = 0;
        
        private String updateNewRuleText()
        {
            String baseText = "if " + newRule.Condition + " then " + newRule.Action;
            baseText = baseText.PadRight(60,' ');
            return baseText;
        }

        public RuleForm()
        {
            InitializeComponent();    
        }
     
        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void RuleForm_Load(object sender, EventArgs e)
        {

        }

        private void runGameToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void ConditionList_SelectedIndexChanged(object sender, EventArgs e)
        {
         
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

       

        private void RuleBeingEdited_Click(object sender, EventArgs e)
        {

        }

        private void ConditionList_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            newRule.Condition = ConditionList.Text;
            RuleBeingEdited.Text = updateNewRuleText();
        }

        private void ActionList_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            newRule.Action = ActionList.Text;

            RuleBeingEdited.Text = updateNewRuleText();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (ruleNameBox.Text.Length <= 0)
                MessageBox.Show("The rule needs a name.", 
                    "Name Entry Error",
                     MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else if (newRule.Action.Length <= 0)
                    MessageBox.Show("The rule needs an action.",
                        "Action Entry Error",
                         MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else
                {
                newRule.RuleName = ruleNameBox.Text;
                rules[numRules] = newRule;
                numRules++;
                newRule.Condition = "";
                newRule.Action = "";
                RuleBeingEdited.Text = updateNewRuleText();
                RuleList.Items.Add(ruleNameBox.Text);
                ruleNameBox.Text = "";
            }
        }

        private void saveToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            using (StreamWriter sw = new StreamWriter("c:/TEMP/agent2.CLP"))
            {
                for (int rule = 0; rule < numRules; rule++)
                {
                    sw.Write("(defrule ");
                    sw.Write(rules[rule].RuleName);
                    sw.Write(" ");

                    if (!rules[rule].Condition.Equals("True"))
                    {
                        sw.Write("(");
                        sw.Write(rules[rule].Condition);
                        sw.Write(")");
                    }
                    sw.Write(" => (assert (");
                    sw.Write(rules[rule].Action);
                    sw.Write(")))");
                    sw.WriteLine();
                }
            }

        }

        private void RuleList_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void ActionList_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void humanPlayToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Agent1 ship1 = (Agent1)Program.getShip1();
            ship1.humanPlay = !ship1.humanPlay;
        }

        private void humanPlay2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Agent1 ship2 = (Agent1) Program.getShip2();
            ship2.humanPlay = !ship2.humanPlay;

        }
    }
}